# -*- coding: utf-8 -*-
"""World_Bank.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1YNwGoGaNlz4hm1UXwrLzS4aubrDg5ToF
"""
import pandas as pd

import psycopg2
import numpy as np
import matplotlib.pyplot as plt
import matplotlib.font_manager

import missingno as msno
from fancyimpute import IterativeImputer

# Import all models
from pyod.models.abod import ABOD
from pyod.models.cblof import CBLOF
from pyod.models.feature_bagging import FeatureBagging
from pyod.models.hbos import HBOS
from pyod.models.iforest import IForest
from pyod.models.knn import KNN
from pyod.models.lof import LOF
from pyod.models.mcd import MCD
from pyod.models.ocsvm import OCSVM
from pyod.models.pca import PCA
from pyod.models.lscp import LSCP
from pyod.models.suod import SUOD
from pyod.models.suod import LOF
from pyod.models.suod import COPOD
from pyod.models.suod import IForest
import seaborn as sns

def trusted_zone_world_bank():


    conn = psycopg2.connect(
        host="localhost",
        database="postgres",
        user="postgres",
        password="ADSDB")
    cursor=conn.cursor()

    cursor.execute("SELECT * FROM public.world_data_bank_source20220103")
    data=cursor.fetchall()
    query="select c.column_name from information_schema.columns c where table_catalog='postgres' and table_schema='public' and table_name='world_data_bank_source20220103'"
    cursor.execute(query)
    def tu(tupla):
        return tupla[0]
    columns=cursor.fetchall()
    columns=list(map(tu,columns))

    df2=pd.DataFrame(data, columns=columns)



    """**Potential Variables**
    
    We select 15 variables from the total of 1443 to perform a preliminary profile.
    """

    country=df2['Country Name']
    year=df2['Year']
    p_indicators=[
                      'Individuals using the Internet (% of population)',
                      'Population growth (annual %)',
                      'Vulnerable employment, total (% of total employment) (modeled ILO estimate)',
                      'Government expenditure on education, total (% of GDP)',
                      'Inflation, consumer prices (annual %)',
                      'International migrant stock (% of population)',
                      'Rural population (% of total population)',
                      'Taxes on goods and services (% value added of industry and services)',
                      'Taxes on income, profits and capital gains (% of total taxes)',
                      'Unemployment, total (% of total labor force) (national estimate)',
                      'Children in employment, total (% of children ages 7-14)',
                      'Compulsory education, duration (years)',
                      'Coverage of unemployment benefits and ALMP (% of population)',
                      'Domestic general government health expenditure (% of GDP)',
                      'GDP growth (annual %)']

    df2=df2.loc[:, df2.columns.isin(p_indicators)]
    df2.insert(0, 'Country Name', country)
    df2.insert(1, 'Year', year)

    """We consider 0 value as non-registered value for that year and country, so it is a NA. """

    df2=df2.replace(0.00, np.nan)

    """Profile **World_Bank_report** table"""



    """*   With the profiling we can observe that apriori there is no missing values, but we detect that it's because they're been classified as "Zeros". 
    *  6,18% of the observations are zeros (27.961). However, we could identify that those missings are concentrated mainly in some variables. Since those variables are not representative and not meaningfull to interpret our dataframe, we decided to drop them. The threshold stablished is over 20% of missings, thus we eliminated:
    - "Children in employment, total (% of children ages 7-14)" -  95,3% missings
    - "Coverage of unemployment benefits and ALMP (% of population)" - 95,0% missings
    - "Domestic general government health expenditure (% of GDP)" - 27,3% missings
    - "Government expenditure on education, total (% of GDP)" - 42,9% missigs
    - "International migrant stock (% of population)" - 82,6% missings
    - "Taxes on goods and services (% value added of industry and services)" - 60,8% missings
    - "Taxes on income, profits and capital gains (% of total taxes)" - 60,1% missings
    - "Unemployment, total (% of total labor force) (national estimate)" - 47,4% missings
    - "Vulnerable employment, total (% of total employment) (modeled ILO estimate)" - 22,0%
    
    From the preliminaries, we mantain 6 variables. 
    
    
    """


    ##Database case
    miss_columns=['Vulnerable employment, total (% of total employment) (mode702',
                      'Government expenditure on education, total (% of GDP)',
                      'International migrant stock (% of population)',
                      'Taxes on goods and services (% value added of industry and652',
                      'Taxes on income, profits and capital gains (% of total taxes)',
                      'Unemployment, total (% of total labor force) (national est685',
                      'Children in employment, total (% of children ages 7-14)',
                      'Coverage of unemployment benefits and ALMP (% of population)',
                      'Domestic general government health expenditure (% of GDP)']


    df2=df2.drop(columns=miss_columns)

    df2=df2.drop([4521,4522])


    """# **Univariate Outliers:**
    Variables with no outliers: 
    
    1.   Individuals using internet
    2.   Rural Population
    
    Severe outliers are considered as missing values
    
    
    """

    # Commented out IPython magic to ensure Python compatibility.


    year=df2['Year']
    country=df2['Country Name']
    X=df2.drop(columns=['Year', 'Country Name'])

    ax=sns.boxplot(data=X, orient="h", palette='Set2')

    def tukeys_method(df, variable):
        #Takes two parameters: dataframe & variable of interest as string
        q1 = df[variable].quantile(0.25)
        q3 = df[variable].quantile(0.75)
        iqr = q3-q1
        inner_fence = 1.5*iqr
        outer_fence = 3*iqr

        #inner fence lower and upper end
        inner_fence_le = q1-inner_fence
        inner_fence_ue = q3+inner_fence

        #outer fence lower and upper end
        outer_fence_le = q1-outer_fence
        outer_fence_ue = q3+outer_fence

        outliers_prob = []
        outliers_poss = []
        for index, x in enumerate(df[variable]):
            if x <= outer_fence_le or x >= outer_fence_ue:
                outliers_prob.append(index)
        for index, x in enumerate(df[variable]):
            if x <= inner_fence_le or x >= inner_fence_ue:
                outliers_poss.append(index)
        return outliers_prob, outliers_poss
    X_=X.drop(columns=['Rural population (% of total population)', 'Individuals using the Internet (% of population)'])
    uni_outliers={}
    for column in X_.columns:
      severe, mild = tukeys_method(X_, column)
      uni_outliers.update({column:{"Severe":len(severe), "Mild":len(mild)}})
      X[column][severe]=np.nan




    """# **Missing data problem:**
    If we bump into more than 1 zero in a row, the row won't be reliable as we are missing 33% of that register, so it will be dropped out.  From 4522 rows, after the missing treatment, we got 3699 rows.
    """

    X['counts']=X.isnull().sum(axis=1)
    X=X.drop(X[X['counts']>1].index)
    X=X.drop(columns='counts')

    X.insert(0, 'Country Name', country)
    X.insert(1, 'Year', year)

    X=X.drop_duplicates()

    X=X.reset_index()
    X=X.drop(columns=['index'])

    X.isnull().sum()

    """# **Imputation missing values**
    First, we explored the data missingness in order to see if there's some pattern in the missing values. We conclude that our data is Missing at random, so we use MICE imputation.
    """

    sns.set(rc = {'figure.figsize':(15,6)})



    """# **MICE Imputation**"""

    X=X.drop(columns=['Year', 'Country Name'])

    mice_imputer=IterativeImputer()
    df2_imputed=mice_imputer.fit_transform(X)

    X_imputed=pd.DataFrame(df2_imputed, columns=X.columns)


    df_imputed_knn = pd.DataFrame(imputer.fit_transform(df),columns = df.columns)




    X_imputed.isnull().sum()

    """# **Multivariate outliers using Pyod:**
    SUOD method with majority vote is used with different algorithms in order to detect multivariate outliers
    
"""
    random_state = np.random.RandomState(42)

    # initialized a group of outlier detectors for acceleration
    detector_list = [LOF(n_neighbors=15), LOF(n_neighbors=20),
                     LOF(n_neighbors=25), LOF(n_neighbors=35),
                     KNN(), KNN(method='mean'),
                     COPOD(), IForest(n_estimators=100),MCD(random_state=random_state),PCA(random_state=random_state),
                     IForest(n_estimators=200), FeatureBagging(LOF(n_neighbors=35),
                           random_state=random_state), IForest(random_state=random_state), IForest(random_state=random_state)]

    # decide the number of parallel process, and the combination method
    # then clf can be used as any outlier detection model
    clf_suod = SUOD(base_estimators=detector_list, n_jobs=2, combination='majority Vote',
               verbose=False)
    clf_suod.fit(X_imputed)
    outilers=clf_suod.predict(X_imputed)
    sum(outilers)

    X_imputed['outliers']=outilers
    df2=X_imputed.drop(X_imputed[X_imputed['outliers']==1].index)
    df2.insert(0, 'Country Name', country)
    df2.insert(1, 'Year', year)
    df2=df2.reset_index()
    df2=df2.drop(columns='outliers')
    df2=df2.drop(columns=['index'])



    df2['Country Name']=df2['Country Name'].apply(lambda x: x.replace("'",""))

    conn = psycopg2.connect(
        host="localhost",
        database="postgres",
        user="postgres",
        password="ADSDB")
    cursor=conn.cursor()

    tpls = [tuple(x) for x in df2.to_numpy()]
    cols = '" ,"'.join(list(df2.columns))
    cols='"'+cols+'"'
    for i in range(len(tpls)):
      query="INSERT INTO {0}({1}) VALUES ("
      query  = query.format("public.world_data_bank_source20220123", cols)
      tupla=list(tpls[i])

      tupla[0]="'"+tupla[0]+"'"
      tupla[1]="'"+tupla[1]+"'"
      tupla=tuple(tupla)
      for index, v in enumerate(tupla) :
        if index==len(tupla)-1:
          break
        query=query+str(v)+', '
      query=query+str(tupla[len(tupla)-1])+')'
      cursor.execute(query)
      print(tupla[0]+" inserted")
    conn.commit()

